/*
 * errno.h
 */


#ifndef share_errno_h
#define share_errno_h


#ifndef ASM_FILE


/* Error number. */
enum{
	E2BIG =1,		/* 1  Argument list too long. */
	EACCES,			/* 2  Permission denied. */
	EADDRINUSE,		/* 3  in use. */
	EADDRNOTAVAIL,	/* 4  Address not available. */
	EAFNOSUPPORT,	/* 5  Address family not supported. */
	EAGAIN,			/* 6  Resource unavailable, try again (may be the same value as EWOULDBLOCK). */
	EALREADY,		/* 7  Connection already in progress. */
	EBADF,			/* 8  Bad file descriptor. */
	EBADMSG,		/* 9  Bad message. */
	EBUSY,			/* 10 Device or resource busy. */
	ECANCELED,		/* 11 Operation canceled. */
	ECHILD,			/* 12 No child processes. */
	ECONNABORTED,	/* 13 Connection aborted. */
	ECONNREFUSED,	/* 14 Connection refused. */
	ECONNRESET,		/* 15 Connection reset. */
	EDEADLK,		/* 16 Resource deadlock would occur. */
	EDESTADDRREQ,	/* 17 Destination address required. */
	EDOM,			/* 18 Mathematics argument out of domain of function. */
	EDQUOT,			/* 19 Reserved. */
	EEXIST,			/* 20 File exists. */
	EFAULT,			/* 21 Bad address. */
	EFBIG,			/* 22 File too large. */
	EHOSTUNREACH,	/* 23 Host is unreachable. */
	EIDRM,			/* 24 Identifier removed. */
	EILSEQ,			/* 25 Illegal byte sequence. */
	EINPROGRESS,	/* 26 Operation in progress. */
	EINTR,			/* 27 Interrupted function. */
	EINVAL,			/* 28 Invalid argument. */
	EIO,			/* 29 I/O error. */
	EISCONN,		/* 30 Socket is connected. */
	EISDIR,			/* 31 Is a directory. */
	ELOOP,			/* 32 Too many levels of symbolic links. */
	EMFILE,			/* 33 Too many open files. */
	EMLINK,			/* 34 Too many links. */
	EMSGSIZE,		/* 35 Message too large. */
	EMULTIHOP,		/* 36 Reserved. */
	ENAMETOOLONG,	/* 37 Filename too long. */
	ENETDOWN,		/* 38 Network is down. */
	ENETRESET,		/* 39 Connection aborted by network. */
	ENETUNREACH,	/* 40 Network unreachable. */
	ENFILE,			/* 41 Too many files open in system. */
	ENOBUFS,		/* 42 No buffer space available. */
	ENODATA,		/* 43 No message is available on the STREAM head read queue. */
	ENODEV,			/* 44 No such device. */
	ENOENT,			/* 45 No such file or directory. */
	ENOEXEC,		/* 46 Executable file format error. */
	ENOLCK,			/* 47 No locks available. */
	ENOLINK,		/* 48 Reserved. */
	ENOMEM,			/* 49 Not enough space. */
	ENOMSG,			/* 50 No message of the desired type. */
	ENOPROTOOPT,	/* 51 Protocol not available. */
	ENOSPC,			/* 52 No space left on device. */
	ENOSR,			/* 53 No STREAM resources. */
	ENOSTR,			/* 54 Not a STREAM. */
	ENOSYS,			/* 55 Function not supported. */
	ENOTCONN,		/* 56 The socket is not connected. */
	ENOTDIR,		/* 57 Not a directory. */
	ENOTEMPTY,		/* 58 Directory not empty. */
	ENOTSOCK,		/* 59 Not a socket. */
	ENOTSUP,		/* 60 Not supported. */
	ENOTTY,			/* 61 Inappropriate I/O control operation. */
	ENXIO,			/* 62 No such device or address. */
	EOPNOTSUPP,		/* 63 Operation not supported on socket. */
	EOVERFLOW,		/* 64 Value too large to be stored in data type. */
	EPERM,			/* 65 Operation not permitted. */
	EPIPE,			/* 66 Broken pipe. */
	EPROTO,			/* 67 Protocol error. */
	EPROTONOSUPPORT,/* 68 Protocol not supported. */
	EPROTOTYPE,		/* 69 Protocol wrong type for socket. */
	ERANGE,			/* 70 Result too large. */
	EROFS,			/* 71 Read-only file system. */
	ESPIPE,			/* 72 Invalid seek. */
	ESRCH,			/* 73 No such process. */
	ESTALE,			/* 74 Reserved. */
	ETIME,			/* 75 Stream ioctl() timeout. */
	ETIMEDOUT,		/* 76 Connection timed out. */
	ETXTBSY,		/* 77 Text file busy. */
	EWOULDBLOCK,	/* 78 Operation would block (may be the same value as EAGAIN). */
	EXDEV,			/* 79 Cross-device link. */

	POSIX_LAST_ERR_NUMBER=EXDEV,
};


#endif


#endif
